#include "RmtPunch.h"
#include  "cbw.h"

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <time.h>
#include <conio.h>

#define   PUNCHLEN   1        // the time between when you apply the strobe and the time you take it off
#define   CYCLETIME  100      // time to complete one punch cycle
#define   SPUNCHTIME  10      // srobe 10 ms for normal punch
#define   SRELTIME    15      // strobe 15 MS for release time
 

// funct =1 flash LED on board
// funct =2 write (data) out to port (port) 
// funct =3 read (data) back from port (port)
// 

unsigned short  STROBE=0x01;      // bit for strobe line
unsigned short  NOSTROBE=0x00;    // no bit for clear


FILE 	 *in;
extern char	outFileName[64];
extern int cardCount;
extern int cardsToSkip;



int	relayCntl(int ,int , unsigned short *);
int CommAccess(int, int);

	unsigned short bits16;
	unsigned short high8;
	unsigned short low8;
	unsigned short allOff=0;
	DWORD          relTime;




void punchThemCards()
 
{
	int i;
	int endofjob;
	int k;
	int cards;
	int punchCount=0;
	int comTime=SPUNCHTIME;

	if ((in = fopen(outFileName, "r")) == NULL)
	{
		fprintf(stderr, "Cannot open input file to punchAcard file %s\n",
		       outFileName);
		fprintf(stderr,"Press any key to exit......");
		getch();
		return;
	}

	cards=0;
	k=0;
	endofjob=0;
	

	fprintf(stderr,"Starting to punch cards\n\n");
	for(EVER)
	{
		// set the leds to the number of cards left to punch
		if((cardCount-cards) > 255)
		{
			low8=0x0f;
			high8=0x0f;
		}
			else
		{
			low8=(cardCount-cards)& 0x0F;
			high8=(cardCount-cards) >>4;
		}
		
		i=relayCntl(SETRELAY,FIRSTPORTCL,&low8);//  low order bits 
		if(i != 0)
		{
			fprintf(stderr,"\nGot an error on relay control for low8\n");
			break;
		}
	
		i=relayCntl(SETRELAY,FIRSTPORTCH,&high8);
		if(i != 0)
		{
			fprintf(stderr,"\nGot an error on relay control for high8\n");
			break;
		}


		// read in the next punch
		i=fread(&bits16,2,1,in);
		if((i == EOF) || (i < 1))
		{
			bits16=P14;  //set an extra release
			endofjob=1;  //signal we are done
		}
	
		if(kbhit())
		{
			i=getch(); // get rid of the key that was pressed
		
			for(EVER)
			{
				fprintf(stderr,"\n\nPress 'C' to continue\n");
				fprintf(stderr,"Press 'E' to exit\n");
				i=getch();
			
				if((i=='C') || (i=='c'))
				{
					break;
				}
				if((i=='E') || (i=='e'))
				{
					bits16=P14;  //set an extra release
					endofjob=1;  //signal we are done
					break;
				}
			}
		}
	
			low8=bits16 & 0x00ff;
			high8=bits16/256;

		//printf("cards to skip = %d\n",cardsToSkip);
		if(cardsToSkip == 0)
		{
			i=relayCntl(SETRELAY,FIRSTPORTA,&low8);//  low order bits (punches 9-2)
			if(i != 0)
			{
				fprintf(stderr,"\nGot an error on relay control for low8\n");
				break;
			}
	
			i=relayCntl(SETRELAY,FIRSTPORTB,&high8);
			if(i != 0)
			{
				fprintf(stderr,"\nGot an error on relay control for high8\n");
				break;
			}
	
		
			if(bits16 == P14)
			{
				comTime=SRELTIME;	
			}
			else
			{
				comTime=SPUNCHTIME; 
			}

		
		
			i=CommAccess(WRITE,comTime); // write 10 characters @ 9600 baud
								// this will drive the RTS signal
								// up about 10 ms

				
			punchCount++;
		
			Sleep(CYCLETIME); //Sleep to allow the punch to finish
	
	}
			if(bits16 == P14)
			{
				relTime=510+(80-punchCount)*10; 
				punchCount=0;
			                    // If you only punched 1 colums, relTime is 1250 ms
			                    //if you punched 80 columns, reltime = 500 ms
				if(cardsToSkip == 0)Sleep(relTime);		// wait for the punch unit 
								// to get ready for the next punch
				cards++;
				if(cardsToSkip > 0) cardsToSkip--;
				//printf("cards to skip = %d\n",cardsToSkip);
				fprintf(stderr,"Cards punched = %3.3d  Cards left = %3.3d \r",
				cards,(cardCount-cards));
			} 
	                    
		
	    if(endofjob==1) break; //time to go home
	}	
	
		fprintf(stderr,"\nEnd Punching of cards\n");
}